﻿using System;
using System.Linq;
using System.IO;
using System.Collections.Generic;


namespace erettsegi01_Lotto_Linq
{
    class erettsegi01_Lotto_Linq
    {
        static bool prime(int n)
        {
            int osz=1;
            for (int i = 2; i <= n; i++) if (n % i ==0) osz++;
            return osz==2;
        }

        struct lottószám
        {
            public byte hét;
            public byte szám;
        }
            

        static void Main()
        {
            #region 1. feladat: 52.hét adatainak bekérése
            Console.WriteLine("\n1. Feladat: Az 52. hét adatai:");
            List<lottószám> hét52 = new List<lottószám>(); //52. hét lottószámait egy struktúra típusú listában tároljuk:
            for (int i = 0; i < 5; i++)
            {
                Console.WriteLine("Kérem az 52. hét {0}. számát:", i + 1);
                lottószám szám_segéd = new lottószám() //Segéd struktúra az 52. hét számainak beolvasására
                {
                    hét = 52,
                    szám = byte.Parse(Console.ReadLine()),
                };
                hét52.Add(szám_segéd);
            }

            #endregion

            #region 2. feladat: 52.hét adatainak rendezése, kiiratása
            Console.WriteLine("\n2. Feladat: Az 52. hét adatainak rendezése:");
            foreach (var i in  hét52.OrderBy(w => w.szám)) Console.Write("{0}, ", i.szám);
            Console.WriteLine();
            #endregion

            # region 3. feladat: Hét sorszámának bekérése
            Console.WriteLine("\n3. Feladat: Kérem a vizsgált hét sorszámát:");
            byte vhét = byte.Parse(Console.ReadLine());
            #endregion

            # region 4. feladat: Számok beolvasása, vhét számainak kiiratása
            Console.WriteLine("\n4. Feladat: Vizsgált hét lottószámai:");

            //Lottószámokat egy struktúra típusú listában tároljuk:
            List<lottószám> lsz = new List<lottószám>();

            //Beolvasás:
            using (StreamReader sr = new StreamReader("lottosz.dat"))
            {
                for (byte i = 1; i <= 51; i++)
                {
                    string s = sr.ReadLine(); //Egy hét 5 számát olvassa egy sztringbe (egy sort)
                    string[] számok = s.Split(' '); //Feldaraboljuk a sztringet
                    for (int j = 0; j < 5; j++)
                    {
                        lottószám szám_segéd=new lottószám() //segéd struktúra
                            {
                                hét=i,
                                szám=byte.Parse(számok[j]),
                            };
                        lsz.Add(szám_segéd); //listához adjuk a struktúrát
                    }
                }
            }
            //Vizsgált hét számainak kiírása:
            //var vhét_számai = from i in lsz
            //                  where i.hét == vhét
            //                  select i.szám;

            // foreach (var i in vhét_számai) Console.Write("{0} ,",i);

            //Vizsgált hét számainak kiírása rövidebben:
            foreach (var i in lsz.Where(w => w.hét == vhét)) Console.Write("{0} ,", i.szám);
            Console.WriteLine();
            #endregion

           
            #region 5. feladat: Volt-e olyan szám az 51 hét alatt, amit nem húztak ki?
            Console.WriteLine("\n5. Feladat: Volt-e olyan szám az 51 hét alatt, amit nem húztak ki?");
            var stat = from i in lsz
                       group i by i.szám into g
                       select new { szám = g.Key, db = g.Count() };

            //Ha sikerült a fenti lekérdezésnek 90 csoportot
            //kialakítani, akkor minden számot kihúztak legalább 1x
            Console.WriteLine( stat.Count()==90 ? "Nincs!": "Van!");
            #endregion

            
            #region 6. feladat: Páratlan számok darabszáma
            Console.WriteLine("\n6. Feladat: Páratlan számok darabszáma");

            //páratlan számok listája:
            //var psz_lst = from i in lsz 
            //              where i.szám % 2 != 0
            //              select i;

            //Console.WriteLine("Páratlan számok: {0}",psz_lst.Count());

            //Rövidebben:
            Console.WriteLine("Páratlan számok: {0}",lsz.Where(w => w.szám % 2 != 0).Count());
            #endregion

            
            #region 7. feladat: Fájlkezelés (uj fájl)
            Console.WriteLine("\n7. Feladat: Fájlkezelés");

            //52.hét rendezett adatainak feltöltése a listába
            lsz.AddRange(hét52.OrderBy(w=>w.szám));

            var lsz2 = from i in lsz
                       group i by i.hét into g
                       orderby g.Key
                       select new { Hét=g.Key, Számok=g };

            using (StreamWriter sw = new StreamWriter("lotto52.ki"))
            {
                foreach (var i in lsz2)
                {
                    string ski = "";
                    foreach (var j in i.Számok) ski += j.szám + " ";
                    sw.WriteLine(ski);
                }
            }
            #endregion

            #region  8. feladat: Statisztika
            Console.WriteLine("\n8. Feladat: Statisztika");

            for (int sz = 1; sz <= 90; sz++)
            {
                Console.Write("{0} ", stat.Any(w => w.szám == sz) ? stat.Where(w => w.szám == sz).First().db : 0);
                if (sz % 15 == 0) Console.WriteLine();
            }
            #endregion

            
            #region 9. feladat: Melyik prímszámok nem lettek kihúzva?
            Console.WriteLine("\n9. Feladat: Melyik prím nem lett kihúzva");
            for (int sz = 1; sz <= 90;)
            {
                if (stat.Any(w => w.szám == sz)) { sz++; continue; };
                if (prime(sz) ) Console.WriteLine(sz);
                sz++;
            }

            //Alternatív megoldás:
            byte[] prím_lsz = new byte[] {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89 };
            foreach (var i in prím_lsz.Except( from j in lsz select j.szám)) Console.WriteLine(i);
            #endregion

            Console.ReadKey();
        }
    }
}
